<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class content extends core
{
    /*инициализация объектов для работы данного класса*/
    function content($value)
    {
        $this->core();
                
        $this->type   = $value['type'];
        $this->root   = $value['tree'];
        $this->ncode  = (isset($_COOKIE['nesting_code'])) ? $this->tools->clear_string($_COOKIE['nesting_code']) : '';
        $this->page   = (isset($_GET['page']))            ? $this->tools->clear_int($_GET['page'])               : 1;
        $this->rc     = $value['rc'];
    }

    /* CASE : DEL */
    
    function delete_content($content_id)
    {
        if (!$content = $this->check_content($content_id))
            return FALSE;
        
        $this->db->accept_delete("DELETE FROM rs_content WHERE content_id='".$content_id."'");
        $this->db->accept_delete("DELETE FROM rs_sitemap WHERE sitemap_content='".$content['sitemap_content']."'");
        
        $this->sysDB->delete($content['map_id']);//удаляем системную инфу
        $this->delete_nesting($content_id);
        
        // если подключен модуль облако тегов
        if ($tag = $this->tools->get_object('tag'))
            $tag->delete_tags($content_id);
        
        exit;
    }

    function delete_nesting($content_id)
    {
        $this->delete_files($content_id);
        $this->delete_gallery($content_id);
    }   

    function delete_files($content_id)
    {
        $sql = "SELECT file_path, file_id FROM rs_files WHERE content_id='".$content_id."'";
        
        if (!$files = $this->db->accept_select($sql))
            return FALSE;
            
        foreach ($files as $file)
        {
            if (file_exists($file['file_path']))
                unlink($file['file_path']);
            
            $this->db->accept_delete("DELETE FROM rs_files WHERE file_id='".$file['file_id']."'");
        }
    }
    
    function delete_gallery($content_id)
    {
        $sql = "SELECT gallery_id FROM rs_gallery WHERE content_id='".$content_id."'";
        
        if (!$galleries = $this->db->accept_select($sql))
            return FALSE;
            
        foreach ($galleries as $gallery)
        {
            $sql = "SELECT file_path, file_id FROM rs_gallery_files WHERE gallery_id='".$gallery['gallery_id']."'";
            
            if (!$files = $this->db->accept_select($sql))
                continue;

            foreach ($files as $file)
            {
                $file_path = $file['file_path'];
                
                if (file_exists($file_path))
                    unlink($file_path);
                
                $this->db->accept_delete("DELETE FROM rs_gallery_files WHERE file_id='".$file['file_id']."'");    
            }
            
            $this->db->accept_delete("DELETE FROM rs_gallery WHERE gallery_id='".$gallery['gallery_id']."'");
        }
    }
    /* CASE : CFG */
    
    /*показ формы настроик*/
    function show_form_cfg($content_id)
    {
        $sql = "SELECT * FROM rs_sitemap WHERE sitemap_content='".$content_id."'";
        
        if ($sitemap = $this->db->accept_select($sql))
            $result['sitemap'] = $sitemap[0];
        
        $sql = "SELECT"
            ." user_id, content_view, content_view_comm, content_rss, content_mode_publication"
            ." FROM rs_content"
            ." WHERE content_id='".$content_id."'";
        
        if ($content = $this->db->accept_select($sql))
            $result['content'] = $content[0];
        
        if ($GLOBALS['rssite']['user']['user_access'] == 2)
        {
            $access = $content[0]['user_id'];
            
            if ($access == $GLOBALS['rssite']['user']['user_id'])
                $result['access'] = 'true';
            else
                $result['access'] = 'false';
        }
        else
            $result['access'] = 'true';
        
        $result['content_id'] = $content_id;
        
        return $result;
    }
    
    /*редактирование конфигурации поста*/
    function cfg_content($fields)
    {
        if (!$content = $this->check_content($fields['cfg_content_id']))
            return FALSE;
        
        $sitemap_content = $content['sitemap_content'];
        
        /*обновляем запись поста*/  
        $what = array (
            'content_mode_publication'  => $fields['cfg_public_mode'],
            'content_view'              => $fields['cfg_hide_mode'],
            'content_view_comm'         => $fields['cfg_comm'],
            'content_rss'               => $fields['cfg_rss']
        );
        
        if ($fields['cfg_public_mode'] == 1 AND $fields['cfg_public_mode'] != $content['content_mode_publication'])
            $what['content_publication'] = $this->tools->get_now_date();
        
        $this->db->accept_update($what, "rs_content", "content_id='".$fields['cfg_content_id']."'");
        
        /*обновляем запись карты сайта*/
        $what = array (
            'sitemap_change'    => $fields['cfg_change_sm'],
            'sitemap_priority'  => $fields['cfg_priority_sm'],
            'sitemap_active'    => $fields['cfg_public_sm']
        );
        
        $this->db->accept_update($what, "rs_sitemap", "sitemap_content='".$sitemap_content."'");        
        
        preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
        $referer = $referer[1];
        
        $this->tools->move_to($referer);
    }

    function check_content($content_id)
    {
        $sql = "SELECT sitemap_content, map_id, content_mode_publication FROM rs_content WHERE content_id='".$content_id."'";
        
        if ($sitemap_content = $this->db->accept_select($sql))
            return $sitemap_content[0];
        else
            return FALSE;
    }
    
    /* CASE : EDIT */
    
    /*вывести данные поста из базы данных*/
        
    function show_form_edit($content_id)
    {
        $result = array();
        
        $sql = "SELECT"
        ." c.content_id as content_id, m.map_alias as content_alias, c.content_title as content_title,"
        ." c.content_desc as content_desc, c.content_key as content_key, c.content_announce as content_announce,"
        ." c.content_text as content_text, c.catalog_id as catalog_id, c.user_id as user_id,"
        ." m.map_id as map_id"
        
        ." FROM rs_content c, rs_map m"
        ." WHERE 1=1"
        ." AND c.content_id = '".$content_id."'"
        ." AND c.map_id = m.map_id";
        
        if ($content = $this->db->accept_select($sql))
            $result['content'] = $content[0];
        
        $sql    = "SELECT * FROM rs_user WHERE user_access>='2'";
        $users  = $this->db->accept_select($sql);
            
        $result['users'] = $users;
        
        return $result;
    }
    
    /*Редактировать пост*/
    
    function edit_content($fields)
    {
        $this->check_catalog($fields);
        
        $sql = "SELECT"
            ." m.map_alias as content_alias, c.map_id as map_id, c.user_id as user_id, c.catalog_id as catalog_id"
            ." FROM rs_content c, rs_map m"
            ." WHERE 1=1"
            ." AND c.content_id='".$fields['content_id']."'"
            ." AND c.map_id=m.map_id";

        if (!$content = $this->db->accept_select($sql))
            return FALSE;
        
        $content = $content[0];
        
        if ($GLOBALS['rssite']['user']['user_access'] >= 3 OR $GLOBALS['rssite']['user']['user_id'] == $content['user_id'])
        {
            if ($content['content_alias'] != $fields['content_alias'] OR $content['catalog_id'] != $fields['content_catalog'])
                $fields['content_alias'] = $this->sysDB->check_take_alias($fields['content_alias'], $fields['map_parent']);
        
            $fields['content_user'] = $this->check_user($fields['content_user']);
            $fields['map_id'] = $content['map_id'];
            
            $map_array = array(
                'map_id'            => $fields['map_id'],
                'map_parent'        => $fields['map_parent'],
                'map_alias'         => $fields['content_alias'],
                'map_name'          => $fields['content_name']
            );
            
            $this->sysDB->update_map($map_array);

            // если подключен модуль облако тегов
            if ($tag = $this->tools->get_object('tag'))
                $tag->edit_tags($fields);

            $this->update_content($fields);
            
            preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
            $referer = $referer[1];
        
            $this->tools->move_to($referer);
        }       
    }
    
    /*обновляем пост*/
    
    function update_content($fields)
    {
        $what = array
        (
            'content_title'     => $fields['content_name'],
            'content_desc'      => $fields['content_desc'],
            'content_key'       => $fields['content_key'],
            'content_announce'  => $fields['content_announce'],
            'content_text'      => $fields['content_text'],
            'user_id'           => $fields['content_user'],
            'catalog_id'        => $fields['content_catalog']
        );
        
        $this->db->accept_update($what, 'rs_content', "content_id='".$fields['content_id']."'");
    }
    
    /* CASE : BROWSE */
    
    function get_all_content($type, $fields)
    {
        if (empty($fields))
            $this->set_filter($fields);
        else
            if (!$this->save_date($fields))
                $this->set_filter($fields);
        
        $filter = $this->collect_filter_sql($fields);
        
        // получаем инфу о навигации
        $param = array(
            'modul'    => 'content',// вообще это имя таблицы без приставки rs_
            'type'     => $type,
            'rc'       => $this->rc,
            'page'     => $this->page,
            'where'    => $filter['navigation']
        );
        
        if ($GLOBALS['rssite']['user']['user_access'] == 2)
            $param['where'] .= " AND user_id = '".$GLOBALS['rssite']['user']['user_id']."'";

        $navigation = $this->navigation->set_navigation($param);

        $sql = ""
            ."SELECT"
                ." c.content_title as title,"
                ." u.user_login as login,"
                ." c.catalog_id as catalog_id,"
                ." c.content_num_comm as comm,"
                ." c.content_id as id,"
                ." m.map_alias as alias,"
                ." c.content_mode_publication as mode"
            ." FROM"
                ." rs_content c,"
                ." rs_user u,"
                ." rs_map m"
            ." WHERE 1=1"
                ." AND c.user_id = u.user_id"
                ." AND c.map_id = m.map_id"
                ." AND c.content_type = '".$type."'"
                ." AND ".$filter['content'];
        
        if ($GLOBALS['rssite']['user']['user_access'] == 2)
            $sql .= " AND c.user_id = '".$GLOBALS['rssite']['user']['user_id']."'"; 
        
            $sql .= " ORDER BY c.content_publication DESC"
                 ." LIMIT ".$navigation['navigation']['rc']." OFFSET ".$navigation['navigation']['offset'];// подключаем лимит навигации

        if (!$content = $this->db->accept_select($sql))
            return array('filter' => $this->get_filter($fields));
        
        foreach ($content as $key => $value)
        {
            $content[$key]['catalog_alias'] = $content[$key]['alias'];
            
            if (!preg_match("/^.*?\.html$/", $content[$key]['alias']))
                $content[$key]['alias']     = $content[$key]['alias'].'/';

            $content[$key]['catalog_name']  = ($value['catalog_id'] == 0) ? 'Нет категории' : $this->get_name_catalog($value['catalog_id']);
            
            // ищим путь до записи по каталогу
            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $this->root, $path);

            $content[$key]['link']          = (!empty($path)) ? implode('/', array_reverse($path)) : '';
        }
        
        $result['content']      = $content;
        $result['type']         = $type;
        $result['navigation']   = $navigation['navigation'];// массив с информацией о навигации. понадобится для шаблонной функции вывода постранички
        $result['filter']       = $this->get_filter($fields);
        
            
        return $result;
    }
    
    function collect_filter_sql($fields)
    {
        $filter = array();
        
        // ищем автора
        if (!empty($fields['author']))
        {
            if ($GLOBALS['rssite']['user']['user_access'] > 2)
            {
                $sql = "SELECT user_id FROM rs_user WHERE user_name LIKE '%".$fields['author']."%' OR user_login LIKE '%".$fields['author']."%'";
                
                if ($users = $this->db->accept_select($sql))
                {
                    $fields['author'] = array();
                    
                    foreach ($users as $user)
                        $fields['author'][] = "'".$user['user_id']."'";
                }
                else
                    $fields['author'] = '';
            }
            else
                $fields['author'] = '';
        }
        
        // собираем sql запрос для поиска сообщений
        $filter['content'] = ""
            ."c.content_publication BETWEEN '".$fields['start']."' AND '".$fields['end']."'"
            .( ($fields['status'] != 2) ? ( ($fields['status'] == 0) ? " AND c.content_mode_publication = '0'" : ( ($fields['status'] == 1) ? " AND c.content_mode_publication = '1'" : "" ) )  : "" )
            .( (!empty($fields['author'])) ? " AND u.user_id IN (".implode(',', $fields['author']).")" : "" )
            .( (!empty($fields['title'])) ? " AND c.content_title LIKE '%".$fields['title']."%'" : "" );

        $filter['navigation'] = ""
            ."content_publication BETWEEN '".$fields['start']."' AND '".$fields['end']."'"
            .( ($fields['status'] != 2) ? ( ($fields['status'] == 0) ? " AND content_mode_publication = '0'" : ( ($fields['status'] == 1) ? " AND content_mode_publication = '1'" : "" ) )  : "" )
            .( (!empty($fields['author'])) ? " AND user_id IN (".implode(',', $fields['author']).")" : "" )
            .( (!empty($fields['title'])) ? " AND content_title LIKE '%".$fields['title']."%'" : "" );

        return $filter;
    }
    
    function get_name_catalog($catalog_id)
    {
        $result = '';
        
        if (!empty($GLOBALS['rssite']['cachecatalog'][$this->root]))
        {
            foreach ($GLOBALS['rssite']['cachecatalog'][$this->root] as $value)
            {
                if ($value['id'] == $catalog_id)
                {
                    $result = $value['name'];
                    break;
                }
            }
        }
        
        if ($result == '')
            $result = "Каталог&nbsp;удален";
        
        return $result;
    }

    /* получаю корректную дату и статус для выборки записей */
    function set_filter(&$fields)
    {
        if (isset($_COOKIE['content_filter_'.$this->type]))
        {
            $filter = unserialize($_COOKIE['content_filter_'.$this->type]);
            
            $fields['start']    = $filter['start'];
            $fields['end']      = $filter['end'];
            $fields['status']   = $filter['status'];
            $fields['author']   = $filter['author'];
            $fields['title']    = $filter['title'];
            
            return TRUE;
        }
        
        $fields['start']     = '2010-01-01 00:00:00';
        $fields['end']       = date('Y-m-d').' 23:59:59';
        $fields['status']    = 2;
        $fields['author']    = '';
        $fields['title']     = '';
        
        return TRUE;
    }
    
    /* если присланный массив с фильтром не пустой, то необходимо его проверить и записать в куку */
    function save_date(&$fields)
    {
        if (!$this->tools->check_date($fields['start']))
            return FALSE;
            
        if (!$this->tools->check_date($fields['end']))
            return FALSE;
            
        if ($fields['status'] < 0 OR $fields['status'] > 2)
            return FALSE;
        
        $fields['start']     = $fields['start'].' 00:00:00';
        $fields['end']       = $fields['end'].' 23:59:59';
        
        setcookie('content_filter_'.$this->type, serialize($fields), time()+60*60, '/');
        return TRUE;
    }
    
    function get_filter($fields)
    {
       $start = explode(' ', $fields['start']);
       $start = explode('-', $start[0]); 

       $end   = explode(' ', $fields['end']);
       $end   = explode('-', $end[0]);
               
       $result = array(
           'sday'         => $start[2],
           'smonth'       => $start[1],
           'syear'        => $start[0],
           'eday'         => $end[2],
           'emonth'       => $end[1],
           'eyear'        => $end[0],
           'status'       => $fields['status'],
           'title'        => $fields['title'],
           'author'       => $fields['author']
       );
        
        return $result;
    }
    
    /* CASE : ADD */
    
    function show_form()
    {
        $result = array();
        
        $sql    = "SELECT * FROM rs_user WHERE user_access>='2'";
        $users  = $this->db->accept_select($sql);
        
        $result = $users;
        
        if (empty($this->ncode))
        {
            $ncode = md5($GLOBALS['rssite']['user']['user_login'].time());
            setcookie('nesting_code', $ncode, time()+(24*60*60), '/');
        }
        
        return $result;
    }
    
    function add_content($fields)
    {       
        $this->check_catalog($fields);
        
        $fields['content_alias']    = $this->sysDB->check_take_alias($fields['content_alias'], $fields['map_parent']);
        $fields['content_user']     = $this->check_user($fields['content_user']);
        
		$map_array = array(
            'map_parent'    => $fields['map_parent'],
            'map_name'      => $fields['content_name'],
            'map_alias'     => $fields['content_alias']
        );
        $fields['map_id']           = $this->sysDB->insert_map($map_array);

        $content_id                 = $this->insert_content($fields);
        
        $this->add_nesting($content_id);
        
        // подключение модулей
        // END подключение модулей

        // если подключен модуль облако тегов
        if ($tag = $this->tools->get_object('tag'))
        {
            $fields['content_id'] = $content_id;
            $tag->add_tags($fields);
        }

        preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
        $referer = $referer[1];
        
        $this->tools->move_to($referer);
    }
    
    function add_nesting($content_id)
    {
        if (!empty($this->ncode))
        {
            $sql = "SELECT gallery_id FROM rs_gallery WHERE gallery_code='".$this->ncode."' AND content_id='0'";
            
            if ($gallerys = $this->db->accept_select($sql))
            {
                foreach ($gallerys as $gallery)
                {
                    $what = array(
                        'gallery_code' => '',
                        'content_id'   => $content_id
                    );
                    
                    $this->db->accept_update($what, 'rs_gallery', "gallery_id='".$gallery['gallery_id']."'");
                }
            }

            $sql = "SELECT file_id FROM rs_files WHERE file_code='".$this->ncode."' AND content_id='0'";
            
            if ($files = $this->db->accept_select($sql))
            {
                foreach ($files as $file)
                {
                    $what = array(
                        'file_code'  => '',
                        'content_id' => $content_id
                    );
                    
                    $this->db->accept_update($what, 'rs_files', "file_id='".$file['file_id']."'");
                }
            }
            
            setcookie('nesting_code', '', time()-(24*60*60), '/');
        }
    }
    
    /*Вставляем запись в таблицу RS_POST*/
    
    function insert_content($fields)
    {
        $what = array
        (
            'map_id'                    => $fields['map_id'],
            'content_title'             => $fields['content_name'],
            'content_desc'              => $fields['content_desc'],
            'content_key'               => $fields['content_key'],
            'content_announce'          => $fields['content_announce'],
            'content_text'              => $fields['content_text'],
            'user_id'                   => $fields['content_user'],
            'content_type'              => $fields['content_type'],
            'content_more'              => (isset($fields['content_more'])) ? $fields['content_more'] : 0,
            'content_publication'       => $this->tools->get_now_date(),
            'catalog_id'                => $fields['content_catalog'],
            'content_num_comm'          => 0,
            'content_view'              => 0,
            'content_view_comm'         => 1,
            'content_rss'               => 0,
            'sitemap_content'           => 0,
            'content_mode_publication'  => 0,
            'content_look'              => 0
        );
        
        $content_id = $this->db->accept_insert($what, 'rs_content', 'content_id');
        
        $this->db->accept_update(array('sitemap_content' => $content_id), 'rs_content', "content_id='".$content_id."'");
        
        $this->db->accept_insert(array('sitemap_content' => $content_id),'rs_sitemap');
        
        return $content_id;     
    }
    
    /*Проверка категории + определение id каталога в rs_map*/
    
    function check_catalog(&$fields)
    {
        if ($fields['content_catalog'] != 0)
        {
            $sql = "SELECT map_id, catalog_id FROM rs_catalog WHERE catalog_id = '".$fields['content_catalog']."'";
            
            if ($map_id = $this->db->accept_select($sql))
            {
                $result['catalog_id']   = $map_id[0]['catalog_id'];
                $result['map_id']       = $map_id[0]['map_id'];
            }
        }
        
        if (!isset($result))
        {
            $result['catalog_id']   = 0;    
            $result['map_id']       = $this->root;
        }
                    
        $fields['content_catalog'] = $result['catalog_id'];
        $fields['map_parent']      = $result['map_id'];
    }


    /*проверка, существует ли юзер*/
    
    function check_user($user_id)
    {
        $check = FALSE;
        
        if ($GLOBALS['rssite']['user']['user_access'] >= 3)
        {
            $users = $this->show_form();
            
            foreach ($users as $value)
            {
                if ($value['user_id'] == $user_id)
                {
                    $check = TRUE;
                    break;
                }
            }           
        }
        
        if ($check == TRUE)
            return $user_id;
        else
            return $GLOBALS['rssite']['user']['user_id'];
    }
}
?>