<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class nesting extends core
{
    /*инициализация объектов для работы данного класса*/
    function nesting($value)
    {
        $this->core();
        
        $this->type   = $value['type'];
        $this->ncode  = (isset($_COOKIE['nesting_code'])) ? $this->tools->clear_string($_COOKIE['nesting_code']) : '';
    }
    
    /* CASE : BROWSE */
    function show_list ($content_id)
    {
        $this->check_access($content_id);
        
        $result = array();
        
        $result['files']   = $this->show_files($content_id);
        $result['gallery'] = $this->show_gallery($content_id);
        
        return $result;
    }
    
    function show_files($content_id)
    {
        if ($content_id == 0)
            if (empty($this->ncode))
                return array();
                
        $sql  = "SELECT * FROM rs_files WHERE";
        $sql .= ($content_id == 0) ? " file_code='".$this->ncode."'" : " content_id='".$content_id."'";
        $sql .= " ORDER BY file_id DESC";
        
        if (!$files = $this->db->accept_select($sql))
            return array();
            
        return $files;
    }

    function show_gallery($content_id)
    {
        if ($content_id == 0)
            if (empty($this->ncode))
                return array();
                
        $sql  = "SELECT g.gallery_id as gallery_id, gallery_name, gallery_code,"
            ." content_id, file_id, file_name, file_path"
                ." FROM rs_gallery g LEFT JOIN rs_gallery_files f ON"
            ." g.gallery_id=f.gallery_id WHERE";
        $sql .= ($content_id == 0) ? " g.gallery_code='".$this->ncode."'" : " g.content_id='".$content_id."'";
        $sql .= " ORDER BY g.gallery_id DESC, f.file_id ASC";

        if (!$gallery = $this->db->accept_select($sql))
            return array();
  
        $result = array();
        $array  = array();
        
        foreach ($gallery as $key => $value)
        {
            if (!isset($array[$value['gallery_id']]))
            {
                $array[$value['gallery_id']] = array(
                  'gallery_id'    => $value['gallery_id'],
                  'gallery_name'  => $value['gallery_name'],
                  'gallery_code'  => $value['gallery_code'],
                  'content_id'    => $value['content_id']
                );
            }
            
            if ($value['file_id'] != NULL)
            {
                $array[$value['gallery_id']]['files'][] = array(
                    'file_id'    => $value['file_id'],
                    'file_name'  => $value['file_name'],
                    'file_path'  => $value['file_path']
                );
            }
        }
        
        foreach ($array as $value)
            $result[] = $value;
        
        return $result;
    }
    /* CASE : ADDFILE */
    
    function add_file (&$fields)
    {
        if ($fields['content_id'] == 0)
            if (empty($this->ncode)) {
                $fields['error'] = 'content_id.empty';
                return FALSE;
            }

        if (empty($fields['nesting_file'])) {
            $fields['error'] = 'file.empty';
            return FALSE;
        }
        
        $this->check_access($fields['content_id']);
        
        $file = $fields['nesting_file'];
        
        $file['type'] = mime_content_type($file['tmp_name']);

        $formats_array = array(
            'application/x-rar-compressed',
            'application/zip',
            'image/jpeg',
            'image/gif',
            'image/png',
            'image/bmp'
        );

        if (!in_array($file['type'], $formats_array)) {
            $fields['error'] = 'format.wrong';
            return FALSE;
        }
            
        $this->get_expansion($file['type']);
        
        $name = preg_replace('/(.*?)\.[a-z]{3,4}$/', '$1', $this->tools->get_translit($file['name']));
        
        if (mb_strlen($name) >= 32) {
            $fields['error'] = 'name.long';
            return FALSE;
        }
            
        if ($file['size'] > 6*1024*1024) {
            $fields['error'] = 'file.size';
            return FALSE;
        }
        
        $name = $this->check_name(trim($name), 'files');

        copy($file['tmp_name'], "content/files/".$name.$this->expansion);
        
        $what = array(
          'file_name'  => $fields['nesting_name'],
          'file_path'  => 'content/files/'.$name.$this->expansion,
          'file_type'  => ($this->expansion == '.rar' OR $this->expansion == '.zip') ? 0 : 1,
          'file_code'  => ($fields['content_id'] == 0) ? $this->ncode : '',
          'content_id' => $fields['content_id']
        );
        
        $this->db->accept_insert($what, 'rs_files');
    }
    
    function check_name($name, $folder, $sel = '')
    {
        if (file_exists("content/".$folder."/".$name.$sel.$this->expansion))
        {
            if ($sel == '')
                $sel = 0;
            
            $sel++;
            
            $result = $this->check_name($name, $folder, $sel);
        }
        else
            $result = $name.$sel;
            
        return $result;
    }
    
    function get_expansion($type)
    {
        switch($type)
        {
            case 'application/x-rar-compressed':
                $this->expansion = '.rar';
                break;
            case 'application/zip':
                $this->expansion = '.zip';
                break;
            case 'image/jpeg':
                $this->expansion = '.jpg';
                break;
            case 'image/gif':
                $this->expansion = '.gif';
                break;
            case 'image/png':
                $this->expansion = '.png';
                break;
            case 'image/bmp':
                $this->expansion = '.bmp';
                break;
        }        
    }

    /* CASE : EDITFILE */
    
    function show_edit_file($file_id)
    {
        $sql = "SELECT * FROM rs_files WHERE file_id='".$file_id."'";
        
        if (!$result = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $this->check_access($result[0]['content_id']);
        
        return $result[0];
    }
    
    function edit_file($fields)
    {
        $sql = "SELECT content_id FROM rs_files WHERE file_id='".$fields['file_id']."'";
        
        if (!$content_id = $this->db->accept_select($sql))
            die();
        
        $this->check_access($content_id[0]['content_id']);
        
        $this->db->accept_update(array('file_name' => $fields['nesting_name']), 'rs_files', "file_id='".$fields['file_id']."'");
        
        die();
    }
    
    /* CASE : DELETEFILE */
    
    function delete_file($file_id)
    {
        $sql = "SELECT file_path, content_id FROM rs_files WHERE file_id='".$file_id."'";
        
        if ($file = $this->db->accept_select($sql))
        {
            $this->check_access($file['content_id']);           
            
            $file = $file[0]['file_path'];//str_replace("/content/files", "content/files", $file[0]['file_path']);
            
            if (file_exists($file))
                unlink($file);
            
            $this->db->accept_delete("DELETE FROM rs_files WHERE file_id='".$file_id."'");
        }
    }
    
    /* CASE : ADDGALLERY */
    
    function add_gallery($fields)
    {
        if ($fields['content_id'] == 0)
            if (empty($this->ncode))
                die();
        
        $this->check_access($fields['content_id']);
        
        $what = array(
          'gallery_name'  => $fields['gallery_name'],
          'gallery_code'  => ($fields['content_id'] == 0) ? $this->ncode : '',
          'content_id'    => $fields['content_id']
        );
        
        $this->db->accept_insert($what, 'rs_gallery');
        
        die();
    }
    
    /* CASE : DELETEGALLERY */
    
    function delete_gallery($gallery_id)
    {
        $sql = "SELECT file_path, file_id FROM rs_gallery_files WHERE gallery_id='".$gallery_id."'";
        
        if ($files = $this->db->accept_select($sql))
        {
            $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$gallery_id."'";
            
            if (!$content_id = $this->db->accept_select($sql))
                return FALSE;
            
            $this->check_access($content_id[0]['content_id']);
            
            foreach ($files as $file)
            {
                $file_path = $file['file_path'];//str_replace("/content/photo", "content/photo", $file['file_path']);
                
                if (file_exists($file_path))
                    unlink($file_path);
                
                $this->db->accept_delete("DELETE FROM rs_gallery_files WHERE file_id='".$file['file_id']."'");    
            }
        }
        
        $this->db->accept_delete("DELETE FROM rs_gallery WHERE gallery_id='".$gallery_id."'");
    }

    /* CASE : EDITPHOTO */

    function show_edit_photo($file_id)
    {
        $sql = "SELECT * FROM rs_gallery_files WHERE file_id='".$file_id."'";
        
        if (!$result = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$result[0]['gallery_id']."'";
        
        if (!$content_id = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $this->check_access($content_id[0]['content_id']);
        
        return $result[0];          
    }
    
    function edit_photo($fields)
    {
        $sql = "SELECT gallery_id FROM rs_gallery_files WHERE file_id='".$fields['file_id']."'";
        
        if (!$gallery_id = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$gallery_id[0]['gallery_id']."'";
        
        if (!$content_id = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $this->check_access($content_id[0]['content_id']);        

        $what = array(
            'file_name'        => $fields['file_name'],
            'file_description' => $fields['file_desc']
        );

        $this->db->accept_update($what, 'rs_gallery_files', "file_id='".$fields['file_id']."'");
        
        die();        
    }

    /* CASE : EDITGALLERY */
    
    function show_edit_gallery($gallery_id)
    {
        $sql = "SELECT * FROM rs_gallery WHERE gallery_id='".$gallery_id."'";
        
        if (!$result = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $this->check_access($result[0]['content_id']);
        
        return $result[0];        
    }
    
    function edit_gallery($fields)
    {
        $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$fields['gallery_id']."'";
        
        if (!$content_id = $this->db->accept_select($sql))
            $this->tools->not_found();        
        
        $this->check_access($content_id[0]['content_id']);
        
        $this->db->accept_update(array('gallery_name' => $fields['gallery_name']), 'rs_gallery', "gallery_id='".$fields['gallery_id']."'");
        
        die();
    }

    /* CASE : ADDPHOTO */

    function add_photo(&$fields)
    {        
        if (empty($fields['nesting_photo'])) {
            $fields['error'] = 'nesting.empty';
            return FALSE;
        }

        $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$fields['gallery_id']."'";
        
        if (!$content_id = $this->db->accept_select($sql)) {
            $fields['error'] = 'content_id.empty';
            return FALSE;        
        }
        
        $this->check_access($content_id[0]['content_id']);
        
        $photo = $fields['nesting_photo'];
        
        $formats_array = array(
            'image/jpeg',
            'image/gif',
            'image/png',
            'image/bmp'
        );

        if (!in_array($photo['type'], $formats_array)) {
            $fields['error'] = 'format.wrong';
            return FALSE;
        }
            
        $this->get_expansion($photo['type']);
        
        $name = preg_replace('/(.*?)\.[a-z]{3,4}$/', '$1', $this->tools->get_translit($photo['name']));
        
        if (mb_strlen($name) >= 32) {
            $fields['error'] = 'name.long';
            return FALSE;
        }
            
        if ($photo['size'] > 6*1024*1024) {
            $fields['error'] = 'file.size';
            return FALSE;
        }
        
        $name = $this->check_name(trim($name), 'photo');

        copy($photo['tmp_name'], "content/photo/".$name.$this->expansion);
        
        $what = array(
          'file_name'          => $fields['photo_name'],
          'file_path'          => 'content/photo/'.$name.$this->expansion,
          'file_description'   => $fields['photo_desc'],
          'gallery_id'         => $fields['gallery_id']
        );
        
        $this->db->accept_insert($what, 'rs_gallery_files');        
    } 

    /* CASE : DELETEPHOTO */

    function delete_photo($file_id)
    {
        $sql = "SELECT file_path, gallery_id FROM rs_gallery_files WHERE file_id='".$file_id."'";
        
        if ($file = $this->db->accept_select($sql))
        {
            $sql = "SELECT content_id FROM rs_gallery WHERE gallery_id='".$file[0]['gallery_id']."'";
            
            if (!$content_id = $this->db->accept_select($sql))
                $this->tools->not_found();
            
            $this->check_access($content_id[0]['content_id']);
            
            $file = $file[0]['file_path'];//str_replace("/content/files", "content/files", $file[0]['file_path']);
            
            if (file_exists($file))
                unlink($file);
            
            $this->db->accept_delete("DELETE FROM rs_gallery_files WHERE file_id='".$file_id."'");        
        }
    }

    //проверка прав
    
    function check_access($content_id)
    {
        $access     = $GLOBALS['rssite']['user']['user_access'];
        $activ_user = $GLOBALS['rssite']['user']['user_id'];
        
        if ($access >= 3)
            return TRUE;
        
        /* 
         * Значения ключа type
         * file    - работа с файлами
         * gallery - работа с галереями
         * photo   - работа с фото
         */
         
         if ($content_id == 0)
             return TRUE;

         $sql = "SELECT user_id FROM rs_content WHERE content_id='".$content_id."'";
         
         if ($user_id = $this->db->accept_select($sql))
         {
             if ($activ_user == $user_id[0]['user_id'])
                 return TRUE;
             else
                 $this->tools->not_found(); 
         }        
         
         $this->tools->not_found(); 
    }
}
?>