<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class fields_group extends core
{
	/*инициализация объектов для работы данного класса*/
	public function fields_group($value)
	{
		$this->core();
        
		$this->typeAlias    = $value['type'];
        $this->type         = str_replace('-', '_', $value['type']);
        $this->suffix_table = $value['suffix'];
	}

    /* CASE : BROWSE */
    public function show_all_group()
    {
        $sql = "SELECT * FROM rs_fields_group";
        
        if (!$groups = $this->db->accept_select($sql))
            return array();
            
        return $groups;
    }

    /* CASE : DELETE */

    public function delete_group($group_id)
    {
        $sql = "SELECT * FROM rs_fields_group WHERE group_id='".$group_id."'";
        if (!$group = $this->db->accept_select($sql))
            die();
        
        $group = $group[0];
        
        $this->db->clear();
        $this->db->set_suffix_table($this->suffix_table);// 'additional_fields'
        $this->db->accept_delete_table(str_replace('-', '_', $group['group_alias']));
        $this->db->accept_delete("DELETE FROM rs_fields_group WHERE group_id='".$group_id."'");
        $this->db->accept_delete("DELETE FROM rs_fields WHERE group_id='".$group_id."'");
        die();
    }

    /* CASE : EDIT */
    
    public function show_group($group_id)
    {
        $sql = "SELECT * FROM rs_fields_group WHERE group_id='".$group_id."'";
        
        if (!$group = $this->db->accept_select($sql))
            return array();
            
        return $group[0];        
    }
    
    public function edit_group($fields)
    {
        $this->db->accept_update(array('group_name' => $fields['group_name']), 'rs_fields_group', "group_id='".$fields['group_id']."'");
        
        $this->tools->move_to('/admin/'.$this->typeAlias.'/');
    }
    
    /* CASE : ADD */
    
    public function show_add_form($fields = array())
    {
        if (!empty($fields))
            return $fields;
        else
            return array();
    }
    
    public function add_group($fields)
    {        
        foreach ($fields as $field)
            if (empty($field))
                return FALSE;

        if ($this->check_alias($fields['group_alias']))
        {
            $what = array(
                'group_name'  => $fields['group_name'],
                'group_alias' => $fields['group_alias']
            );
            
            $this->db->accept_insert($what, 'rs_fields_group');
            
            $this->db->clear();
            $this->db->set_suffix_table($this->suffix_table);
            $this->db->set_type_field('group_id', FALSE, 'int');
            $this->db->accept_create_table(str_replace('-', '_', $fields['group_alias']));
            
            $this->tools->move_to('/admin/'.$this->typeAlias.'/');
        }

        return FALSE;
    }
    
    private function check_alias($alias)
    {
        $sql = "SELECT group_id FROM rs_fields_group WHERE group_alias = '".$alias."'";
        
        if ($group_id = $this->db->accept_select($sql))
            return FALSE;
        
        return TRUE;
    }
}
?>