<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class paramCatalog extends core
{
    /*инициализация объектов для работы данного класса*/
    public function paramCatalog()
    {
        $this->core();
    }
    
    /* CASE : ADD */
    
    public function showForm($fields)
    {
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id,"
                ." gr.group_name   AS group_name"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ." gr.group_parent IS NULL"
            ." ORDER BY gr.group_position"
        ;
        
        if(!$groups = $this->db->accept_select($sql))
            return array();
        
        foreach ($groups as $key => $group)
            $groups[$key]['current'] = (isset($fields['group_id'])) ? ( ($group['group_id'] == $fields['group_id']) ? 'true' : 'false' ) : 'false';
        
        return $groups;
    }

    public function addGroup($fields)
    {
        // проверяем имя значения
        if ($fields['group_id'] === 0)
            return FALSE;
        
        // проверяем наличие выбранной группы
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ."     gr.group_parent IS NULL"
                ." AND gr.group_id      = '".$fields['group_id']."'"
        ;
        
        if (!$this->db->accept_select($sql))
            return FALSE;
        
        $what = array(
            'catalog_id'        => $fields['catalog_id'],
            'group_id'          => $fields['group_id']
        );

        $this->db->accept_insert($what, 'rs_param_catalog');

        return TRUE;
    }
    
    /* CASE : EDIT */

    public function getGroup($catalog_id, $fields)
    {
        if (!empty($fields))
            return $fields;
        
        // находим выбранную группу
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id"
            ." FROM"
                ." rs_param_catalog catalog,"
                ." rs_param_group   gr"
            ." WHERE"
                ."     catalog.catalog_id  = '".$catalog_id."'"
                ." AND gr.group_id         = catalog.group_id"
        ;
        
        if (!$current = $this->db->accept_select($sql))
            return array();
        
        $current = $current[0]['group_id'];
        
        //  выводим все группы
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id,"
                ." gr.group_name   AS group_name"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ." gr.group_parent IS NULL"
            ." ORDER BY gr.group_position"
        ;
        
        if(!$groups = $this->db->accept_select($sql))
            return array();
        
        foreach ($groups as $key => $group)
            $groups[$key]['current'] = ($group['group_id'] == $current) ? 'true' : 'false';
        
        return $groups;            
    }
    
    public function editGroup($fields)
    {
        // проверяем имя значения
        if ($fields['group_id'] === 0)
            return FALSE;
        
        // проверяем наличие выбранной группы
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ."     gr.group_parent IS NULL"
                ." AND gr.group_id      = '".$fields['group_id']."'"
        ;
        
        if (!$this->db->accept_select($sql))
            return FALSE;
        
        $what = array(
            'group_id'          => $fields['group_id']
        );

        $this->db->accept_update($what, 'rs_param_catalog', "catalog_id = '".$fields['catalog_id']."'");

        return TRUE;
    }
    
    /* DELETE */
    
    public function deleteCatalog($catalog_id)
    {
        $this->db->accept_delete("DELETE FROM rs_param_catalog WHERE catalog_id='".$catalog_id."'");
    }
}
?>