<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class param extends core
{
    /*инициализация объектов для работы данного класса*/
    public function param($value)
    {
        $this->core();
        
        // проверки на существование групп
        $this->group_id     = (isset($GLOBALS['groupid']))    ? $this->tools->clear_int($GLOBALS['groupid'])    : '';
        $this->subgroup_id  = (isset($GLOBALS['subgroupid'])) ? $this->tools->clear_int($GLOBALS['subgroupid']) : '';
        $this->param_id     = (isset($GLOBALS['paramid']))    ? $this->tools->clear_int($GLOBALS['paramid'])    : '';

        // проверяем группу
        if ($this->group_id !== '')
            if (!$this->checkGroup($this->group_id))
                $this->tools->not_found();
        
        // проверяем вложенную группу
        if ($this->subgroup_id !== '')
            if (!$this->checkGroup($this->subgroup_id))
                $this->tools->not_found();
                
        // проверяем параметр
        if ($this->param_id !== '')
            if (!$this->checkParam($this->param_id))
                $this->tools->not_found();
    }
        
    /* CASE : BROWSE */
    
    public function getParam()
    {
        $sql = ""
            ."SELECT"
                ." param.param_id         AS param_id,"
                ." param.param_name       AS param_name,"
                ." param.param_type       AS param_type,"
                ." param.group_id         AS group_id,"
                ." param.param_position   AS param_position,"
                
                ." gr.group_parent        AS group_parent"
            ." FROM"
                ." rs_param param,"
                ." rs_param_group gr"
            ." WHERE"
                ."     param.group_id  = '".$this->subgroup_id."'"
                ." AND param.group_id  = gr.group_id"
            ." ORDER BY param.param_position"
        ;

        if (!$params = $this->db->accept_select($sql))
            return array();
        
        $this->getCaptionName();
        
        $type = array(
            'checkbox'    => 'Мультивыбор',
            'radio'       => 'Список'
        );
        
        foreach ($params as $key => $param)
            $params[$key]['param_type_name'] = $type[$param['param_type']];

        return $params;
    } 
    
    /* CASE : ADD */
    
    public function addParam(&$fields)
    {
        // проверяем имя параметра
        if (empty($fields['param_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;            
        }
        
        // проверяем тип параметра
        if (empty($fields['param_type'])) {
            $fields['error'] = 'type.empty';
            return FALSE;            
        }
        
        $type = array(
            'checkbox',
            'radio'
        );
        
        if (!in_array($fields['param_type'], $type)) {
            $fields['error'] = 'type.noexist';
            return FALSE; 
        }
        
        // подсчитываем позицию
        $sql = "SELECT COUNT(*) FROM rs_param WHERE group_id = '".$this->subgroup_id."'";
        
        $param_position  = $this->db->accept_count_select($sql) + 1;
        
        $what = array(
            'param_name'        => $fields['param_name'],
            'param_type'        => $fields['param_type'],
            'group_id'          => $this->subgroup_id,
            'param_position'    => $param_position
        );

        $this->db->accept_insert($what, 'rs_param');

        $this->tools->move_to('/admin/parameter/'.$this->group_id.'/'.$this->subgroup_id.'/');
    }
    
    /* CASE : EDIT */
    
    public function showForm()
    {
        $sql = ""
            ."SELECT"
                ." param.param_id     AS param_id,"
                ." param.param_name   AS param_name,"
                ." param.param_type   AS param_type,"
                ." param.group_id     AS group_id"
            ." FROM"
                ." rs_param param"
            ." WHERE"
                ." param.param_id = '".$this->param_id."'"
        ;
        
        $param = $this->db->accept_select($sql);
        
        return $param[0];            
    }
    
    public function editParam($fields)
    {
        // проверка имени
        if (empty($fields['param_name'])) {
            $fields['error'] = 'name.empty';
            return $fields;
        }
        
        // проверяем тип параметра
        if (empty($fields['param_type'])) {
            $fields['error'] = 'type.empty';
            return $fields;            
        }
        
        $type = array(
            'checkbox',
            'radio'
        );
        
        if (!in_array($fields['param_type'], $type)) {
            $fields['error'] = 'type.noexist';
            return $fields; 
        }
        
        // обновляем запись
        $what = array(
            'param_name'       => $fields['param_name'],
            'param_type'       => $fields['param_type']
        );

        $this->db->accept_update($what, 'rs_param', "param_id='".$this->param_id."'");

        $this->tools->move_to('/admin/parameter/'.$this->group_id.'/'.$this->subgroup_id.'/');
    }

    /* CASE : DELETE */
    
    public function deleteParam($param_id)
    {
        $this->db->accept_delete("DELETE FROM rs_param WHERE param_id='".$param_id."'");
        $this->db->accept_delete("DELETE FROM rs_param_value WHERE param_id='".$param_id."'");
        
        if (!$this->update_position())
            die('ERROR UPDATE POSITION');
        
        die('OK');
    }
    

    /* CASE : POSITION */
    
    function change_position($param_id, $step)
    {
        $sql = ""
            ."SELECT"
                ." param_position"
            ." FROM"
                ." rs_param"
            ." WHERE"
                ."     param_id        = '".$param_id."'"
                ." AND group_id        = '".$this->subgroup_id."'"
        ;
        
        if (!$position = $this->db->accept_select($sql))
            return FALSE;
        
        $old_position = $position[0]['param_position'];
            
        if ($step == 'down')
            $new_position = $position[0]['param_position'] + 1;
            
        if ($step == 'up')
            $new_position = $position[0]['param_position'] - 1;
            
        $sql = ""
            ."SELECT"
                ." param_id"
            ." FROM"
                ." rs_param"
            ." WHERE"
                ."     param_position  = '".$new_position."'"
                ." AND group_id        = '".$this->subgroup_id."'"
        ;
        
        if (!$row_id = $this->db->accept_select($sql))
            return FALSE;
        
        $this->db->accept_update(array('param_position' => $new_position), 'rs_param', 'param_id=\''.$param_id.'\'');
        $this->db->accept_update(array('param_position' => $old_position), 'rs_param', 'param_id=\''.$row_id[0]['param_id'].'\'');
        
        die();
    }
    
    /* РАЗНОЕ */
    
    private function update_position()
    {
        // выводим группы по паренту
        $sql = ""
            ."SELECT"
                ." param_id"
            ." FROM"
                ." rs_param"
            ." WHERE"
                ." group_id = '".$this->subgroup_id."'"
        ;
        
        // обновляем позицию
        if (!$position = $this->db->accept_select($sql))
            return FALSE;


        $new_position = 1;
        foreach ($position as $value)
        {
            $what   = array('param_position' => $new_position);
            $where  = 'param_id=\''.$value['param_id'].'\'';
            
            $this->db->accept_update($what, 'rs_param', $where);
            
            $new_position++;
        }
        
        return TRUE;
    }
    
    private function getCaptionName()
    {
        
        if ($this->group_id !== '') {
            
            $sql = "SELECT group_name FROM rs_param_group WHERE group_id = '".$this->group_id."'";
            
            if ($group_name = $this->db->accept_select($sql))
                $this->tools->get_caption($group_name[0]['group_name'], 'groupid');
        }
        
        if ($this->subgroup_id !== '') {
            
            $sql = "SELECT group_name FROM rs_param_group WHERE group_id = '".$this->subgroup_id."'";
            
            if ($group_name = $this->db->accept_select($sql))
                $this->tools->get_caption($group_name[0]['group_name'], 'subgroupid');
        }
    }
    
    private function checkGroup($group_id)
    {
        $sql = ""
            ."SELECT"
                ." group_id"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ."     group_id = '".$group_id."'"
        ;
        
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
            
        return TRUE;
    }
    
    private function checkParam($param_id)
    {
        $sql = ""
            ."SELECT"
                ." param_id"
            ." FROM"
                ." rs_param"
            ." WHERE"
                ." param_id = '".$param_id."'"
        ;
        
        if (!$param = $this->db->accept_select($sql))
            return FALSE;
            
        return TRUE;
    }
}
?>