<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class widget extends core
{
	/*инициализация объектов для работы данного класса*/
	function widget($value)
	{
        $this->core();
        
        $this->ncode  = (isset($_COOKIE['wnesting_code'])) ? $this->tools->clear_string($_COOKIE['wnesting_code']) : '';
        $this->type   = $value['type'];
	}

	/* CASE : DEL */
	
	function delete_widget($widget_id)
	{
		$this->db->accept_delete("DELETE FROM rs_widget WHERE widget_id='".$widget_id."'");
        
        $this->delete_nesting($widget_id);
		
        // пересчитываем позиции
		$sql = "SELECT widget_id"
			." FROM rs_widget"
			." WHERE widget_type='".$this->type."'"
			." ORDER BY widget_position";
		
		if ($position = $this->db->accept_select($sql))
		{
			$new_position = 1;
			foreach ($position as $value)
			{
				$what	= array('widget_position' => $new_position);
				$where	= 'widget_id=\''.$value['widget_id'].'\'';
				
				$this->db->accept_update($what, 'rs_widget', $where);
				
				$new_position++;
			}
		}
        
        die();
	}

    function delete_nesting($widget_id)
    {
        $this->delete_files($widget_id);
    }

    function delete_files($widget_id)
    {
        $sql = "SELECT file_path, file_id FROM rs_widget_files WHERE widget_id='".$widget_id."'";
        
        if (!$files = $this->db->accept_select($sql))
            return FALSE;
            
        foreach ($files as $file)
        {
            if (file_exists($file['file_path']))
                unlink($file['file_path']);
            
            $this->db->accept_delete("DELETE FROM rs_widget_files WHERE file_id='".$file['file_id']."'");
        }
    }

	/* CASE : CFG */
	
	function show_form_cfg($widget_id)
	{
		$sql = "SELECT"
			." widget_mode_publication"
			." FROM rs_widget"
			." WHERE widget_id='".$widget_id."'";
		
		if ($widget = $this->db->accept_select($sql))
			$result['widget'] = $widget[0];
		
		$result['widget_id'] = $widget_id;
		
		return $result;
	}
	
    function cfg_widget($fields)
	{
		$what = array (
			'widget_mode_publication'	=> $fields['cfg_public_mode'],
		);
		
		if ($fields['cfg_public_mode'] == 1 AND $fields['cfg_public_mode'] != $widget['widget_mode_publication'])
			$what['widget_publication'] = $this->tools->get_now_date();
		
		$this->db->accept_update($what, "rs_widget", "widget_id='".$fields['cfg_widget_id']."'");
        
        $this->tools->move_to('http://'.$_SERVER['HTTP_HOST'].'/admin/'.$this->type.'/');
	}
	
	/* CASE : EDIT */
	
	function show_form_edit($widget_id)
	{
		$result = array();
		
		$sql = "SELECT"
		    ." w.widget_id as widget_id, w.widget_title as widget_title"
		." FROM rs_widget w"
		." WHERE 1=1"
		    ." AND w.widget_id = '".$widget_id."'";
		
		if ($widget = $this->db->accept_select($sql))
			$result['widget'] = $widget[0];
		
		return $result;
	}
	
	function edit_widget($fields)
	{
        $sql = "SELECT"
                ." w.widget_id as widget_id"
            ." FROM rs_widget w"
            ." WHERE 1=1"
                ." AND w.widget_id='".$fields['widget_id']."'";

        if (!$widget = $this->db->accept_select($sql))
            return FALSE;

        if (empty($fields['widget_title']))
            $fields['widget_title'] = time();

        $what = array
        (
            'widget_title'        => $fields['widget_title']
        );

        $this->db->accept_update($what, 'rs_widget', "widget_id='".$fields['widget_id']."'");
		
        $this->tools->move_to('http://'.$_SERVER['HTTP_HOST'].'/admin/'.$this->type.'/');
	}
    	
	/* CASE : BROWSE */
	
	function get_all_widget()
	{
        $sql = ""
			."SELECT"
				." w.widget_title as widget_title,"
				." w.widget_id as widget_id,"
				." w.widget_position as widget_position,"
				." w.widget_mode_publication as widget_mode"
			." FROM"
				." rs_widget w"
			." WHERE 1=1"
				." AND w.widget_type = '".$this->type."'"
                ." ORDER BY w.widget_position";

		if (!$widget = $this->db->accept_select($sql))
			return array();
		
        $result['widget']      = $widget;
        $result['type']        = $this->type;
        	
		return $result;
	}

	/* CASE : POSITION */
	
	function change_position($widget_id, $step)
	{
		$sql = "SELECT widget_position FROM rs_widget WHERE widget_id='".$widget_id."'";
		
		if (!$position = $this->db->accept_select($sql))
			return FALSE;
		
		$old_position = $position[0]['widget_position'];
			
		if ($step == 'down')
			$new_position = $position[0]['widget_position'] + 1;
			
		if ($step == 'up')
			$new_position = $position[0]['widget_position'] - 1;
			
		$sql = "SELECT widget_id"
			." FROM rs_widget"
			." WHERE widget_position='".$new_position."'"
			." AND widget_type='".$this->type."'";
		
		if (!$row_id = $this->db->accept_select($sql))
			return FALSE;
		
		$this->db->accept_update(array('widget_position' => $new_position), 'rs_widget', 'widget_id=\''.$widget_id.'\'');
		$this->db->accept_update(array('widget_position' => $old_position), 'rs_widget', 'widget_id=\''.$row_id[0]['widget_id'].'\'');
		
		die();
	}
	
	/* CASE : ADD */
	
	function show_form()
	{
		$result = array();
        
        if (empty($this->ncode))
        {
            $ncode = md5($GLOBALS['rssite']['user']['user_login'].time());
            setcookie('wnesting_code', $ncode, time()+(24*60*60), '/');
        }
        		        
		return $result;
	}
	
	function add_widget($fields)
	{
		$sql = "SELECT COUNT(*) FROM rs_widget WHERE widget_type='".$this->type."'";
		
		$widget_position = $this->db->accept_count_select($sql) + 1;

		$what = array
		(
			'widget_title'            => $fields['widget_title'],
			'widget_type'             => $fields['widget_type'],
			'widget_more'             => (isset($fields['widget_more'])) ? $fields['widget_more'] : 0,
			'widget_publication'      => $this->tools->get_now_date(),
			'widget_mode_publication' => 0,
            'widget_position'         => $widget_position
		);
		
		$widget_id = $this->db->accept_insert($what, 'rs_widget', 'widget_id');
        
        $this->add_nesting($widget_id);
        
        $this->tools->move_to('http://'.$_SERVER['HTTP_HOST'].'/admin/'.$this->type.'/');
	}
    
    function add_nesting($widget_id)
    {
        if (!empty($this->ncode))
        {
            $sql = "SELECT file_id FROM rs_widget_files WHERE file_code='".$this->ncode."' AND widget_id='0'";
            
            if ($files = $this->db->accept_select($sql))
            {
                foreach ($files as $file)
                {
                    $what = array(
                        'file_code'  => '',
                        'widget_id'  => $widget_id
                    );
                    
                    $this->db->accept_update($what, 'rs_widget_files', "file_id='".$file['file_id']."'");
                }
            }
            
            setcookie('wnesting_code', '', time()-(24*60*60), '/');
        }
    }
}
?>