<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class cachecatalog extends core
{
    function cachecatalog($value)
    {
        $this->core();
        $GLOBALS['rssite']['currentcatalog'] = 'FALSE';
    }

    function get_station()
    {
        if($cache = $this->cache->readerCACHE('catalogcache', $_GET['chpu_links'], 1*60*60, TRUE))
            return $cache;      
        
        $sql = ""
            ."SELECT"
                ." c.catalog_id         AS id,"
                ." c.catalog_title      AS title,"
                ." c.catalog_desc       AS description,"
                ." c.catalog_follow     AS follow,"
                ." c.catalog_key        AS keyswords,"
                ." m.map_alias          AS alias,"
                ." c.catalog_name       AS name,"
                ." c.catalog_parent     AS parent,"
                ." c.catalog_link       AS link,"
                ." c.catalog_position   AS position,"
                ." c.catalog_tree       AS tree,"
                ." m.map_id             AS map_id"
            ." FROM"
                ." rs_catalog           c,"
                ." rs_map               m"
            ." WHERE 1=1"
                ." AND c.map_id         = m.map_id"
                
                ." ORDER BY c.catalog_position";
        
        if (!$stations = $this->db->accept_select($sql))
            return FALSE;
        
        $result = array();
        
        // определяем базовый путь (в случае если коренем каталога является пункт др каталога)
        foreach ($stations as $key => $station)
        {
            $path = array();
            
            $this->get_base_dir($stations, $station['tree'], $path);

            $stations[$key]['base'] = (!empty($path)) ? implode('/', array_reverse($path)) : '';
        }

        foreach ($stations as $key => $station)
            $result[$station['tree']][] = $stations[$key];

        $this->cache->writeCACHE('catalogcache', $_GET['chpu_links'], $result, TRUE);

        return $result;
    }
    
    // базовый путь
    function get_base_dir($stations, $map_id, &$path)
    {
        foreach ($stations as $station)
        {
            if ($station['map_id'] == $map_id)
            {
                $path[] = $station['alias'];
                
                if ($station['parent'] != 0)
                    $this->get_parents_dir($stations, $station['parent'], $path);
                
                $this->get_base_dir($stations, $station['tree'], $path);
            }
        }
    }
    
    // пути между двумя корнями
    function get_parents_dir($stations, $parent, &$path)
    {
        foreach ($stations as $station)
        {
            if ($station['id'] == $parent)
            {
                $path[] = $station['alias'];
                
                if ($station['parent'] != 0)
                    $this->get_parents_dir($stations, $station['parent'], $path);
            }
        }
    }
}
?>