<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class catalogcontent extends core
{
    function catalogcontent($value)
    {
        $this->core();
        
        $this->suffix         = $value['suffix'];
        $this->page           = (isset($_GET['page'])) ? $this->tools->clear_int($_GET['page']) : 1;
        $this->rc             = $value['rc'];
        $this->catalog_id     = $value['value'];
    }
    
    function get_catalogcontent()
    {
        $this->get_root();
        $this->get_type();
        
        // получаем инфу о навигации
        $param = array(
            'modul'    => 'content',// вообще это имя таблицы без приставки rs_
            'type'     => $this->type,
            'rc'       => $this->rc,
            'page'     => $this->page,
            'where'    => 'catalog_id='.$this->catalog_id
        );
        
        $navigation = $this->navigation->set_navigation($param);

        $sql = "SELECT"
            ." c.content_id as content_id, c.map_id as map_id, m.map_alias as content_alias, c.content_num_comm as content_comm,"
            ." c.content_title as content_title, c.content_desc as content_desc, c.content_key as content_key,"
            ." c.content_announce as content_announce, c.content_text as content_text, c.content_publication as content_publication,"
            ." c.catalog_id as catalog_id, u.user_id as user_id, u.user_name as user_name, u.user_login as user_login, "
            ." u.user_status as user_status, u.user_access as user_access, f.field_logo as field_logo"
        ." FROM"
            ." rs_content c, rs_map m, rs_user u, rs_".$this->type."_".$this->suffix." f"
        ." WHERE"
            ." c.content_type='".$this->type."'"
            ." AND c.map_id=m.map_id"
            ." AND c.user_id=u.user_id"
            ." AND c.content_view='0'"
            ." AND c.content_mode_publication='1'"
            ." AND c.content_more=f.group_id"
            ." AND c.catalog_id='".$this->catalog_id."'"
            ." ORDER BY c.content_publication DESC"
            ." LIMIT ".$navigation['navigation']['rc']." OFFSET ".$navigation['navigation']['offset'];// подключаем лимит навигации

        if (!$post = $this->db->accept_select($sql))
            $this->tools->not_found();

        foreach($post as $key => $value)
        {
            $GLOBALS['rssite']['currentcatalog'] = $this->catalog_id;
            
            if (!preg_match("/^.*?\.html$/", $post[$key]['content_alias']))
                $post[$key]['content_alias'] = $post[$key]['content_alias'].'/';
            
            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $this->root, $path);

            $post[$key]['content_link']         = implode('/', array_reverse($path));
            $post[$key]['content_publication']  = $this->tools->change_date($value['content_publication']);
            
            foreach ($GLOBALS['rssite']['cachecatalog'][$this->root] as $k => $station)
                if ($station['id'] == $value['catalog_id'])
                {
                    $post[$key]['catalog_name']  = (empty($station['link'])) ? $station['name'] : '';
                    break;
                }
        }

        // выводим метатеги страницы
        $GLOBALS['rssite']['cfg']['meta']['two'] = array(
            'meta_title'        => $this->catalog['title'],
            'meta_desc'         => $this->catalog['description'],
            'meta_key'          => $this->catalog['keyswords']
        );
        
        $result['catalog_name'] = $this->catalog['name'];
        $result['content']      = $post;
        $result['navigation']   = $navigation['navigation'];
        
        return $result;
    }
    
    function get_type()
    {
        $sql = "SELECT content_type FROM rs_content WHERE catalog_id='".$this->catalog_id."' LIMIT 1 OFFSET 0";
        
        if (!$content = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $this->type = $content[0]['content_type'];
    }
    
    function get_root()
    {
        foreach ($GLOBALS['rssite']['cachecatalog'] as $key => $catalogs)
            foreach ($catalogs as $catalog)
                if ($catalog['id'] == $this->catalog_id)
                {
                    if (!empty($catalog['link']))
                        $this->tools->move301($catalog['link']);
                        
                    
                    $this->root         = $key;
                    $this->catalog      = $catalog;
                    break; break;
                }
    }
}
?>