<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class map extends core
{
    /*инициализация объектов для работы данного класса*/
    function map()
    {
        $this->core();
        $this->variable = array();
    }
    
    /*метод получение массива с модулями и значениями каждого модуля*/
    function get_modul($chpu)
    {
        if($cache = $this->cache->readerCACHE('map-chpu', $_GET['chpu_links'], 7*24*60*60))
        {
            $this->set_globals($cache['variable']);
            return $cache;
        }
        
        if ($chpu != "")
        {
            $chpu = explode("/", $chpu);
            
            if (count($chpu) > 1)
            {
                foreach ($chpu as $key => $value)
                    if (empty($value)) unset($chpu[$key]);
                
                $newchpu = $chpu;

                unset($chpu);
                
                $chpu[] = ""; // Самый первый элемент должен быть пустым !!! (корень дерева)
                
                foreach ($newchpu as $value)
                    $chpu[] = $value;
            }
            else
            {
                $kren = $chpu[0];
                $chpu = array('', $kren);
            }
        }
        else
            $chpu[0] = '';

        if ($modules = $this->get_chain_links($chpu))
        {
            $this->cache->writeCACHE('map-chpu', $_GET['chpu_links'], $modules);
            
            $this->set_globals($modules['variable']);
            
            return $modules;
        }
        else
            return FALSE;
    }
    
    /*метод позволяет пройти по ветке в карте и отыскать id подключаемых модулей*/
    function get_chain_links($alias)
    {   
        $result = array();
        $parent = 0;

        $this->count = 0;
        
        foreach ($alias as $k => $v)
            $this->get_node_by_alias($v, $result, 'static', $parent);

        if(!empty($result) AND count($alias) == $this->count)
        {
            foreach ($result as $key => $value)
            {
                $modules[]                = (int)$value['map_modules'];
                $breadcrumbs['code'][]    = (string)$value['map_alias'];
                $breadcrumbs['alias'][]   = ($value['map_tree_type'] == 'static') ? (string)$value['map_alias'] : $this->variable[$value['map_alias']];
                $breadcrumbs['name'][]    = (string)$value['map_name'];
            }

            $modules = $this->get_value_modules($modules);
            
            // формируем массив с хлебными крошками
            foreach ($breadcrumbs['name'] as $key => $value)
            {
                $path = ($key > 0) ? $path.$breadcrumbs['alias'][$key].'/' : '/';
                
                $value = strip_tags($value);
                $value = iconv('UTF-8','windows-1251', $value);
                
                if (strlen($value) > 35)
                    $value = substr($value, 0, 35)."...";
                
                $value = iconv('windows-1251', 'UTF-8', $value);
                
                $modules['breadcrumbs'][] = array(
                    'code'        => $breadcrumbs['code'][$key],
                    'name'        => $value,
                    'path'        => $path
                );
            }
            
            // формируем переменные с variable узлами
            if (!empty($this->variable))
                foreach ($this->variable as $node => $variable)
                    $modules['variable'][$node] = $variable;

            return $modules;
        }
        else
            return FALSE;
    }

    function get_node_by_alias($alias, &$result, $type = 'static', &$parent)
    {
        if ($alias !== FALSE)
            $alias = $this->tools->clear_string($alias);
        
        $sql = ""
            ."SELECT"
                ." map.map_id                 AS map_id, "
                ." map.map_parent             AS map_parent, "
                ." map.map_name               AS map_name, "
                ." map.map_alias              AS map_alias, "
                ." map.map_modules            AS map_modules, "
                ." map.map_type               AS map_type, "
                ." map.map_tree_type          AS map_tree_type "
            ."FROM"
                ." rs_map map "
            ."WHERE 1=1"
                .( ($type != 'variable') ? " AND map.map_alias = '".$alias."'" : '' )
                ." AND map.map_tree_type  = '".$type."'"
                ." AND map.map_parent     = '".$parent."'"
        ;
        
        if (!$map = $this->db->accept_select($sql))
        {
            if ($type != 'variable')
                $this->get_node_by_alias($alias, $result, 'variable', $parent);
        }
        else
        {
            if ($type == 'variable')
                $this->variable[$map[0]['map_alias']] = $alias;
            
            $parent   = $map[0]['map_id'];
            $result[] = $map[0];
            
            $this->count++;
        }
    }
    
    /*
     * Метод, используя id модулей полученных в методе get_chain_links,
     * получает значение и имена модулей путем связывание таблиц:
     * - rs_modules
     * - rs_map
     */
    function get_value_modules ($modules)
    {
        foreach ($modules as $value)
        {
            $block = array('t', 'c', 'b');
            
            if ($value != 0)
            {
                $sql = ""
                    ."SELECT"
                        ." m.modul_name         AS modul,"
                        ." c.connect_value      AS value,"
                        ." c.connect_position   AS position,"
                        ." c.connect_block      AS block,"
                        ." c.connect_parent     AS parent"
                    ." FROM"
                        ." rs_modules           m,"
                        ." rs_connect_modules   c"
                    ." WHERE"
                        ."     c.map_modules    = '".$value."'"
                        ." AND c.modul_id       = m.modul_id"
                        
                        ." ORDER BY c.connect_position";
                
                if (!$row = $this->db->accept_select($sql))
                    $result[] = '';
                else
                {
                    for ($i=0; isset($block[$i]); $i++)
                        $massiv[$block[$i]] = array();
                    
                    for ($i=0;isset($row[$i]); $i++)
                    {                           
                        $massiv[$block[$row[$i]['block']]][$row[$i]['position']] = array(
                            'modul'     => $row[$i]['modul'],
                            'value'     => $row[$i]['value'],
                            'parent'    => $row[$i]['parent']
                        );
                    }
                    
                    for ($i=0; isset($block[$i]); $i++)
                        ksort($massiv[$block[$i]]);
                        
                    $result[] = array(
                        't' => $massiv['t'],
                        'c' => $massiv['c'],
                        'b' => $massiv['b'],
                    );
                }
            }
            else
                $result[] = '';
        }
        
        $result = $this->union_modules($result);
        
        return $result;
    }
    
    /*
     * метод объеденяет модули образуя коллекцию родительских и
     * подключенных модулей для последнего элемента дерева
     */
    function union_modules($modules)
    {
        $un_modules = array();

        $all_items = count($modules) - 1;
                
        for ($i=0; isset($modules[$i]); $i++)
        {
            if (!empty($modules[$i]))
            {
                foreach ($modules[$i] as $key => $value)
                {
                    if ($all_items == $i)
                        $this->look_block($key, $value, $un_modules, TRUE);
                    else
                        $this->look_block($key, $value, $un_modules);
                }
            }
        }
        //var_dump($un_modules); die();
        return $un_modules;
    }
    
    /*
     * Вспомогательный метод метода union_modules
     * листает блок (t, с или b) с модулями сливая их в единый массив
     * поделенный на эти самые блоки
     */
    function look_block($block, $massiv, &$un_modules, $end_branch = FALSE)
    {
        foreach ($massiv as $value)
        {
            if ($value['parent'] == 1 OR $end_branch == TRUE)
            {
                if (!isset($un_modules[$block][$value['modul']]))
                    $un_modules[$block][$value['modul']] = $value['value'];
                else
                {
                    $result = array();
                    
                    $value_parent = $this->tools->get_array_value($un_modules[$block][$value['modul']]);
                    $value_branch = $this->tools->get_array_value($value['value']);

                    foreach ($value_branch as $key => $v)
                        $value_parent[$key] = $v;
                    
                    foreach ($value_parent as $key => $v)
                        $result[] = $key.':'.( (is_array($v)) ? implode(',', $v) : $v );
                    
                    $separator  = '{'.time().'}';
                    $result     = implode($separator, $result);
                    $result     = str_replace($separator, LINE, $result);
                    
                    $un_modules[$block][$value['modul']] = $result;
                }
            }
        }
    }

    function set_globals($variables)
    {
        // формируем глобальные переменные с variable узлами
        if (!empty($variables))
            foreach ($variables as $node => $variable)
                $GLOBALS[$node] = $variable;
    }
}
?>